/*
 * Copyright (c) 2005 Kirk Murrin, <mailto:linuxguru1968@yahoo.com>
 * Licensed under the Gnu Public License, version 2.
 * All rights resered.
 * 
 */

#include <netinet/in.h>

#ifndef _CONNECTION_H
#define _CONNECTION_H

typedef  enum conn_close_type { CLOSE=0, KEEP_ALIVE } close_type;
typedef enum enum_conn_status {CONN_OK,CONN_ABORT,CONN_CLOSE} conn_status_type;

typedef struct struct_conn {
    int server_sd;
    int client_sd;
    int addr_len;
    int server_port;
    struct sockaddr_in server_addr;
    struct sockaddr_in client_addr;
    close_type close; 
    int maxfd;
    fd_set readfds;
    fd_set writefds;
    fd_set exceptfds;
    struct timeval timeout;
} connection_type;

int init_server( void );
void print_connection( void );
void clear_connection( void );
void setnonblocking(void);
int create_socket( void );
int bind_socket( void );
int accept_connection( void );
connection_type *get_connection( void );
int check_connection( void );
int get_connection_client_sd( void );
int set_connection_client_sd( int sd );
int get_connection_server_sd( void );
int set_connection_server_sd( int sd );
int get_connection_server_port( void );
int set_connection_server_port( int portnum );
void connection_close_client( void );
void connection_close_server( void );
int connection_listen( void );
long connection_get_connection_s_addr( void );
struct in_addr connection_get_connection_sin_addr( void );

#endif /* */
