/*
 * Copyright (c) 2005 Kirk Murrin, <mailto:linuxguru1968@yahoo.com>
 * Licensed under the Gnu Public License, version 2.
 * All rights resered.
 * 
 */

#include <stdio.h>

#ifndef _HELP_H
#define _HELP_H

typedef struct struct_help_entry 
{
    char variable[128];
    char *description;
    long offset;
    long length;
} help_entry_type;


typedef struct struct_help
{
    char *help_file_path;
    FILE *fptr;
    long start_comment;
    long comment_length;
    help_entry_type *entries;
    long numentries;
} help_type;


int init_help_system( void );
void close_help_system( void );
void print_help( void );
int compare_help_var(const void *s1, const void *s2);
int compare_help_desc(const void *s1, const void *s2);
int output_help_file( void );
//void build_help_file( void );
help_type *get_help_system( void );

#endif
