/*
 * Copyright (c) 2005 Kirk Murrin, <mailto:linuxguru1968@yahoo.com>
 * Licensed under the Gnu Public License, version 2.
 * All rights resered.
 * 
 */

#include "mconfig.h"

#ifndef _HTML_H
#define _HTML_H

/*
* This is the config information for the
* page layout
*/

typedef struct struct_html_config {
  // page config
  int  table_width;
  int  table_height;
  int  max_textarea_rows;
  int  max_textarea_cols;
  int  char_pixel_width;
  int  char_pixel_height;
  int  button_area_cell_spacing;
  int  button_area_cell_padding;
  int  top_menu_item_width;
  int  top_menu_item_height;
  int  button_win_width;
  int  button_win_height;
  int  main_win_width;
  int  main_win_height;
  int  table_row_height;
  int  table_col_width;
  char *page_bg_color;
  char *table_bg_color;
  char *top_menu_bg_color;
  char *button_area_bg_color;
  char *page_bg_image;
  int  table_border;
  char *help_prompt;
  char *dir_pointer_prompt;
} html_config_type;

void start_content(void);
void end_content(void);
void start_page(void);
void end_page(void);
void start_body(void);
void end_body(void);
void start_page_file(void);
void end_page_file(void);
void start_body_file(void);
void end_body_file(void);
void start_form(char *method ); 
void end_form(void); 
void start_form_file(char *target, char *method ); 
void end_form_file(void); 
void add_caption( char *caption );
void start_table_percent(int cellSpacing, int cellPadding, int width, int height, char *bgcolor, int border);
void start_table(int cellSpacing, int cellPadding, int width, int height, char *bgcolor, int border);
void end_table( void );
void start_table_percent_file(int cellSpacing, int cellPadding, int width, int height, char *bgcolor, int border);
void start_table_file(int cellSpacing, int cellPadding, int width, int height, char *bgcolor, int border);
void end_table_file();
void start_center( void );
void end_center( void );
void start_row( void );
void start_row_new( int height );
void start_row_col_new( int height, int width ); 
void end_row( void );
void start_col( void ); 
void start_col_new(char *valign, char *align, int width, int height, int colspan, char *bgcolor);
void start_col_new_percent(char *valign, char *align, int width, int height, int colspan, char *bgcolor);
void start_col_color( char *color ); 
void add_heading( char *heading );
void end_col( void ); 
void start_row_col( void ); 
void end_row_col( void );
void start_link(char *href);
void start_pointer_link(const statement_type *statement );
void add_dir_link(char *dirpath, char *name, char *title );
void add_dir_str(char *name );
void add_file_link(char *filepath, char *name, char *title );
void end_link( void );
void end_link_file( void );
void add_submit(char *name, char *value);
void start_textarea(int rows, int cols, int readonly, char *name );
void end_textarea( void );
void add_str(char *str);
void add_help_link(symbol_type  *symbol);
void start_frameset( void );
void end_frameset( void );
void start_noframe( void );
void end_noframe( void );
void start_frame( char *src );
void end_frame( void );
void start_iframe(char *name, char *src, int width, int height, int parent );
void end_iframe( void );
void add_br(void);
void start_div( int width, int height );
void end_div( void );
void add_comment( char *comment );
void start_font( char *face, char *color , int size ); 
void end_font( void );
void start_p( void );
void end_p( void );
void start_select(char *name, int size );
void end_select(char *nama, int size );
void add_option( char*value, char  *prompt );
void start_bold( void );
void end_bold( void );
void start_pre( void );
void end_pre( void );

#endif /* _HTML_uu */
