/*
 * Copyright (c) 2005 Kirk Murrin, <mailto:linuxguru1968@yahoo.com>
 * Licensed under the Gnu Public License, version 2.
 * All rights resered.
 * 
 */

#include <time.h>
#include "response.h"
#include "request.h"
#include "html.h"

#include "logout_page.h"

extern html_config_type page_config;

page_type logout_page = {
        "Logout",	
        "&nbsp;",
        "&nbsp;",
        handle_logout, 
        {
             NONE,{ "",          "",          "",          }
        }
};


void logout_do_logout( void )
{
    pop_to_top();
    session_set_cwd("/");
    init_session();
    init_stack();
    set_response_connection_close(1);
}


int handle_logout( void )
{
   char *method;
   method = get_request_method();
   set_response_title(NULL);
   if ( strcasecmp(method,"GET") == 0 ) {
      logout_do_logout();
      setup_logout();
      return SEND_PAGE;
   } else {
   }
}

int setup_logout( void ) 
{
  int rc, len,i,fd;
  time_t curtime;
  struct tm *gm_time;
  char *line=NULL;

  curtime = time (NULL);
  gm_time = gmtime(&curtime);

  start_page();
  start_body();
  start_table(0,0,0,0,page_config.table_bg_color,page_config.table_border);
  start_row_col(); 
  append_page_data_body("<h1>Goodbye!</h1>");
  end_row_col();
  end_table();
  end_body();
  end_page();

}
