/*
 * Copyright 1998, 1999 Michael Elizabeth Chastain, <mailto:mec@shout.net>.
 * Licensed under the Gnu Public License, version 2.
 * 
 *
 * Copyright (c) 2005 Kirk Murrin, <mailto:linuxguru1968@yahoo.com>
 * Licensed under the Gnu Public License, version 2.
 *  S2lyayBNdXJyaW4= 
 * All rights resered.
 * HTTP interface
 *
 * Current maintaineer as of 2005 @debian.org: roman@debian.org
 * dumputmp: Written by Andrew G. Morgan. Copylefted and subject to the GNU GPL.
 * 
 * base64.c http://www.cs.columbia.edu/~hgs/ doesnt know author; license unknown
 *
 * Mini uptime implementation for busybox
 *
 * Copyright (C) 1999,2000 by Lineo, inc.
 * Written by Erik Andersen <andersen@lineo.com>, <andersee@debian.org>
 * 
 */

#include "config.h"

#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/utsname.h>
#include <sys/ioctl.h>
#include <sys/sysinfo.h>
#include <net/if.h>  
#include <sys/mman.h>
#include <netinet/in.h>
#include <linux/tcp.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <libgen.h>
#include <fcntl.h>
#include <signal.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/types.h>
#include <dirent.h>
#include <grp.h>
#include <pwd.h>
#include <utmp.h>
#include <syslog.h>
#include <string.h>

#include "mconfig.h"
#include "connection.h"
#include "request.h"
#include "response.h"
#include "session.h"
#include "pages.h"
#include "help.h"
#include "html.h"

#include "parser.tab.h"
#include "base64.h"

extern char **environ;
extern int errno;

block_type *parser_block_top;

struct utsname Utsname;

extern html_config_type page_config;

sys_config_type sys_config = {
        //"Documentation/Configure.help",	// Path to help file
        "/usr/src/linux/Documentation/Configure.help",	// Path to help file
        //"/tmp/build.txt",	 // Local host path to  build output file
        "build.txt",	         // Local host path to  build output file
        "help.htm",	         // Local host path to  help file
        "/var/log/syslog",	 // Local host path to syslog file
        //"/usr/src/linux/Documentation/Configure.help",	// Local host path to syslog file
        024,                     // Chunk size
        4,                       // Chunk size
        32768,                   // max textarea file size 32768 or 65536,
        "/bin/reboot",           // reboot command
        4,                       // Number of login tries allowed within timeout period
        10,                      // Login period time out
        300                      // Idle connection timeout seconds
};

/*
 * This is the top-level driver for http mode.
 */

void do_mode_menu(const block_type *block)
{
       int reuse_addr = 1;
       int logopt = LOG_PID | LOG_CONS;
       int facility = LOG_USER;
       int priority = LOG_ERR | LOG_USER;
       int ret=0;
       char cwd[256];

       openlog(argument.cmdname,logopt,facility);

       syslog(LOG_ERR|LOG_USER,"do_mode_menu: starting");

       if ( argument.daemon == 1 ) {
           if ( ret=daemon(1,0) == -1 ) {
               perror("do_mode_menu: daemon");
               syslog(LOG_ERR|LOG_USER,"do_mode_menu: daemon failed");
               exit(errno);
           }
       } else {
       }

       memset(cwd,0x0,sizeof(cwd));

       syslog(LOG_ERR|LOG_USER,"do_mode_menu: cwd: %s",cwd);

       printf("do_mode_menu: cwd  %s\n",cwd);

       memset(&Utsname,0x0,sizeof(Utsname));
       if ( uname(&Utsname) == -1 ) {
          perror("uname failed");
       }

       parser_block_top = (block_type*) block;
       init_session(); // Must go first

       init_help_system();
       create_build_file();
       set_response_title(NULL);
       init_stack();

       atexit(cleanup);

       signal(SIGALRM,close_conn);

       /*
       signal(SIGHUP,reload);
       signal(SIGALRM,read_hung);
       signal(SIGQUIT,sig_quit);
       signal(SIGINT,sig_quit);
       signal(SIGPIPE,sig_pipe);
       */

create_conn:

       set_connection_server_port(argument.port);

       init_server();
       /*
       ret=create_socket();
       if ( ret < 0 ) {
           exit(ret);
       }

       //setnonblocking();

       ret=bind_socket();
       if ( ret < 0 ) {
           exit(ret);
       }

       ret=connection_listen();
       if ( ret < 0 ) {
           exit(ret);
       }
       */
 
       for (EVER) {

            ret=accept_connection();

            do {              
                syslog(LOG_ERR|LOG_USER,"do_mode_menu: about to get request");
                if ( read_request() == -1 ) {
                    syslog(LOG_ERR|LOG_USER,"do_mode_menu: read_request failed");
                    connection_close_client();
                    break;
                }
                //print_request();
                //Reset idle connection alarm-after each complete request received.
                alarm(sys_config.conn_timeout_secs);
                process_request();
                syslog(LOG_ERR|LOG_USER,"do_mode_menu: finished process_request");
            } while ( check_connection() == 0 );
	}

}

void cleanup( void ) {
    syslog(LOG_ERR|LOG_USER,"cleanup:start");
    parser_block_top=NULL;
    clear_request();
    clear_session();
    clear_response();
    close_help_system();
    connection_close_client();
    connection_close_server();
    clear_connection();
    syslog(LOG_ERR|LOG_USER,"cleanup: closing log");
    closelog();
}

void close_conn( int signum ) 
{
    syslog(LOG_ERR|LOG_USER,"close_conn: signum %d",signum);
    clear_request();
    clear_response();
    clear_session();
    logout_do_logout();
    connection_close_client();
    syslog(LOG_ERR|LOG_USER,"close_conn: done");
}

void reload( int signum ) {
}

void sig_quit( int signum ) {
    cleanup();
    connection_close_client();
    connection_close_server();
    printf("sig_quit\n");
    exit(signum);
}
/*
void make_path(char *fmt, ...)
{
   va_list arg_ptr;
   char tmpstr[256];
   int len;
   const char *p;

   //va_start(arg_ptr, fmt);
  // memset(tmpstr,0x0,sizeof(tmpstr));
  // memset(title,0x0,sizeof(title));
  // len=vsprintf(tmpstr,fmt,arg_ptr);
  // va_end(arg_ptr);
}

void free_memory(void **voidptr )
{
    if ( *voidptr != NULL ) {
       free(*voidptr);
    }
    *voidptr = NULL;
}


void free_string(char **strptr)
{
    free_memory((void**)strptr);
}

void reset_string_value(char **strptr, char **newval )
{ 
    free_string(strptr);
    if ( *newval != NULL ) {
       *strptr = strdup(*newval);
    }
}

char *my_strndup(char **str, int len)
{
    char *tmpstr=NULL;
    if ( *str != NULL && len > 0 ) {
        tmpstr = (char*)malloc(len+1);
        if ( tmpstr ) {
            memset(tmpstr,0x0,len+1);
            memcpy(tmpstr,*str,len);
        }
    }
    return tmpstr;
}
*/
