/*
 * Copyright (c) 2005 Kirk Murrin, <mailto:linuxguru1968@yahoo.com>
 * Licensed under the Gnu Public License, version 2.
 * All rights resered.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <fcntl.h>
#include <math.h>
#include <unistd.h>
#include <ctype.h>
#include <string.h>
#include <syslog.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "request.h"
#include "response.h"
#include "session.h"
#include "connection.h"
#include "pages.h"
#include "vv_array.h"
#include "page_util.h"

char *strndup(const char *s, size_t n);

extern int errno;

request_type Request;        // The client browser request
line_type ReadLine;          // Global reading buffer

int parse_request_line( void )
{
    char *tptr, *start,*uri_str;
    long len;
    //char *method,*uri_str;
    //float ver;

    start=&ReadLine.line[0];
    for(tptr= &ReadLine.line[0];*tptr!=' '&& *tptr!='\0';tptr++);
    if ( *tptr != '\0' ) {
       len = tptr-start;
       Request.method = (char*)malloc(len+1);
       memset(Request.method,0x0,len+1);
       memcpy(Request.method,start,len);
       if ( strcasecmp(Request.method,"GET")  != 0  &&
            strcasecmp(Request.method,"POST") != 0 ) {
            return -1;
       }
    }

    start = ++tptr;
    while(*tptr != ' ' && *tptr != '\0') tptr++;
    if ( *tptr != '\0' ) {
       len = tptr - start;
       uri_str = (char*)malloc(len+1);
       memset(uri_str,0x0,len+1);
       memcpy(uri_str,start,len);
       split_uri(&uri_str,len);
       //if ( strcasecmp(Request.method,"POST") == 0 && Request.uridatalen > 0){
       if ( Request.uridatalen > 0){
          parse_parameters(&Request.uridata,Request.uridatalen);
       }
       free(uri_str);
    }
    tptr++;
    if ( strncasecmp("HTTP/",tptr,5) == 0 ) {
        tptr += 5;
        Request.protocol_ver = strtod(tptr, (char **)NULL);
    } else {
       return -1;
    }
    return 0;
}

int split_uri( char **str, long strlen )
{
    char *tptr,*start,*last;
    long urilen,datalen;
 
    //if ( strcasecmp((*str),"/") == 0 ) {
     //   tptr = start = last = *str + 1; 
    //} else {
    //    tptr  = *str + 1;  
     //   start = *str + 1; 
      //  last  = *str + (strlen-1)*sizeof(char);
    //}

    tptr  = *str;  
    start = *str; 
    last  = *str + (strlen-1)*sizeof(char);

    while ( tptr != last ) 
    {
        if ( *tptr == '?' ) {
            //urilen = tptr-start+1;
            urilen = tptr-start;
            Request.uri = (char*)malloc(urilen+1);
            memset(Request.uri,0x0,urilen+1);
            memcpy(Request.uri,start,urilen);
            //Request.uri=strndup(start,urilen);
            unescape(&Request.uri,&urilen);

            if ( tptr != last ) {
                //datalen = last - (tptr+1);
                datalen = last - tptr;
                if ( datalen > 0 ) {
                    Request.uridata = (char*)malloc(datalen);
                    memset(Request.uridata,0x0,datalen);
                    memcpy(Request.uridata,tptr+1,datalen);
                    //Request.uridata=strndup(tptr+1,datalen);
                    Request.uridatalen = datalen;
                }
            }
            break;
        }
        tptr++;
    }
    if ( tptr == last && *tptr != '?' ) {
            urilen = tptr-start+1;
            /*Request.uri=(char*)malloc(urilen+1);
            memset(Request.uri,0x0,urilen+1);
            memcpy(Request.uri,start,urilen);
            */
            Request.uri=strndup(start,urilen);
    }
    return 0;
}

int parse_parameters(char **data, long datalen)
{
    char *tptr,*start,*equal,*atsym,*last,*action,*target;
    long len,varlen,vallen,cnt;
    char *varptr=NULL, *valptr=NULL;

    clear_vars(&Request.parameters);

    if (  *data != NULL && datalen > 0 ) {
        cnt = 0;
        last=(*data)+(datalen-1)*sizeof(char);
        for(start=*data,tptr=*data,len=0,atsym=last,equal=NULL; ;len++,tptr++ )
        {
            switch( *tptr )
            {
                case '&':
                    atsym=tptr;
                    if ( equal != start ) {
                        varptr = start;
                        varlen = equal-start;
                        valptr=equal+1;
                        vallen = atsym-equal-1;
                        // Filter out special paramters from rest of posted values
                        if ( strncasecmp(varptr,PARAM_ACTION,varlen) == 0 ) {
                            action=strndup(equal+1,vallen);
                            unescape(&action,&vallen);
                            Request.action = action;
                        } else {
                            if ( strncasecmp(varptr,PARAM_TARGET,varlen) == 0 ) {
                                target=strndup(equal+1,vallen);
                                unescape(&target,&vallen);
                                Request.target = target;
                            } else {
                                add_var(&Request.parameters,&varptr,varlen,&valptr,vallen);
                            }
                        }
                        tptr=start = atsym+1;
                        equal=NULL;
                        atsym=last;
                    }
                break;
                case '=':
                    equal=tptr;
                break;
            }
            if ( len == datalen ) {
                varptr = start;
                varlen = equal-start;
                valptr = equal+1;
                vallen = (last-valptr)+1;
                // Filter out special paramters from rest of posted values
                if ( strncasecmp(varptr,PARAM_ACTION,varlen) == 0 ) {
                    action=strndup(equal+1,vallen);
                    unescape(&action,&vallen);
                    Request.action = action;
                } else {
                    if ( strncasecmp(varptr,PARAM_TARGET,varlen) == 0 ) {
                        target=strndup(equal+1,vallen);
                        unescape(&target,&vallen);
                        Request.target = target;
                    } else {
                        add_var(&Request.parameters,&varptr,varlen,&valptr,vallen);
                    }
                }
                break;
            }
        }
        qsort(Request.parameters.vars,Request.parameters.len,
              sizeof(var_value_type),compare_string);
        return 0;
    }
    return -1;
}

int read_request( void )
{
  char *cont_len, *cont_type;
  //char *connection;
  register int i,j,len,varlen,vallen;
  char *ptr, *varptr,*valptr;
  long ret;
  //char buf[128];
  char *delims=";",*cookies,*token;
  long readlen,dataleft;
  int sd;

  sd = get_connection_client_sd();

  syslog(LOG_ERR|LOG_USER,"get_request: starting");

  //printf("This is the previous request:\n");
  //print_request();
  clear_request();

  ret=read_line(sd);

  if ( ret >  0 ) {
      syslog(LOG_ERR|LOG_USER,"get_request: read_line OK");
      ret=parse_request_line();
      if ( ret < 0 ) {
          setup_error(RC_BAD_REQUEST,
           "The request could not be understood by the server due to malformed syntax");
          goto send_error;
      }

      // Read in and parse the header variables
      i=0;
      ret=0;
      while( (ret=read_line(sd)) > 0 ){
          if ( ReadLine.line[0] == '\0' ) {
               break;
          }

          // Split the var/value pairs; trim white spaced?
          ptr = NULL;
          for(j=0; j < ReadLine.len; j++ ) {
              if ( ReadLine.line[j] == ':' ) {
                  ptr = &ReadLine.line[j];
                  break;
              }
          }

          if ( ptr ) {
              ptr++;
              // left trim
              while ( isspace(*ptr) && *ptr != '\0' ) ptr++;

              varptr=&ReadLine.line[0];
              varlen=(ptr-&ReadLine.line[0])-2;
              valptr = ptr;
              vallen = strlen(ptr);

              add_var(&Request.header_variables,&varptr,varlen,&valptr,vallen);
          }

      }
      if ( ret < 0 ) {
          setup_error(RC_BAD_REQUEST,
              "The request could not be understood by the server due to malformed syntax");
          goto send_error;
      }

      qsort(Request.header_variables.vars,Request.header_variables.len,
            sizeof(Request.header_variables.vars[0]),compare_string);

      memset(Request.content_type,'\0',sizeof(Request.content_type));
      cont_type=find_header_value("Content-Type");
      if ( cont_type != NULL ) {
          memcpy(Request.content_type,cont_type,strlen(cont_type));
          free(cont_type);
          cont_type=NULL;
      }

      cont_len=find_header_value("Content-Length");
      if (cont_len != NULL) {
         Request.datalen=atoi(cont_len);
         if ( strcasecmp(Request.method,"POST") == 0 && Request.datalen > 0 ) {
              send_line("HTTP/%2.1f 100 Continue\r\n\r\n",Request.protocol_ver);
              Request.data=malloc(Request.datalen);
              if (  Request.data ) {
                  memset(Request.data,'\0',Request.datalen);
                  readlen=0;
                  dataleft=Request.datalen;
                  do {
                      ret=read(sd,&Request.data[readlen],dataleft);
                      if ( ret >= 0 ) {
                          readlen += ret;
                          dataleft = Request.datalen-readlen;
                      } else {
                          setup_error(RC_INTERNAL_SERVER_ERROR,"Read data failed: %s",
                            strerror(errno));
                          free_string(&Request.data);
                          //free(Request.data); Request.data=NULL;
                          goto send_error;

                      }
                  } while ( dataleft > 0 );
                  if( strcasecmp(Request.content_type,"application/x-www-form-urlencoded") == 0) {
                      parse_parameters(&Request.data, Request.datalen);
                      //print_request_data(&Request.data, Request.datalen);
                  }
              } else {
                  setup_error(RC_INTERNAL_SERVER_ERROR,"Read data malloc failed: %s",
                        strerror(errno));
                  goto send_error;
              }
         }
         free(cont_len);
      }

      /* Check if the client is closing this socket */ 
      /* FIXME: only good for http < 1.1 - need to modify close logic based on http ver */
      /* 
      Connection.close=CLOSE;
      connection=find_header_value("Connection");
      if ( connection ) {
          if ( strcasecmp(connection,"keep-alive") == 0 ) {
              Connection.close=KEEP_ALIVE;
          } else {
              if ( strcasecmp(connection,"close") == 0) {
                  Connection.close=CLOSE;
              }
          }
          free(connection);
      }
      */
      
      cookies=find_header_value("Cookie");
      if ( cookies ) {
          token=strtok(cookies,delims);
          if ( token != NULL ) {
              len = strlen(token);
              ptr=strchr(token,'=');
              if ( ptr ) {
                 varlen=ptr-token;
                 varptr=strndup(token,varlen);
                 vallen=strlen(ptr+1);
                 valptr=strdup(ptr+1);
                 add_var(&Request.cookies,&varptr,varlen,&valptr,vallen);
              }
              while( (token=strtok(NULL,delims)) != NULL ){
                 ptr=strchr(token,'=');
                 if ( ptr ) {
                     varlen=ptr-token;
                     varptr = strndup(token,varlen);
                     vallen=strlen(ptr+1);
                     valptr=strdup(ptr+1);
                     add_var(&Request.cookies,&varptr,varlen,&valptr,vallen);
                 }
              }
          }
          free(cookies);
      }
      return  0;

  } else {
      if ( ret <= 0 ) {
         syslog(LOG_ERR|LOG_USER,"get_request: read_line failed %d",ret);
         return -1;
     }
  }

  syslog(LOG_ERR|LOG_USER,"get_request: end");

  return 0;

send_error:
      send_response();
      clear_response();
      syslog(LOG_ERR|LOG_USER,"get_request: returned error");
      return -1;
}

int read_line( int sd )
{
     char buf[1];
     int cnt;
     int cr_found=0;
     cr_found=0;
     ReadLine.len=0;
     memset(ReadLine.line,0x0,sizeof(ReadLine.line));
     while ( ReadLine.len < sizeof(ReadLine.line) ) {
         memset(buf,0x0,sizeof(buf)); 
	 cnt=recv(sd,buf,sizeof(buf),0);
         if ( cnt < 0  ) {
             perror("read_line abnormal end of file");
             return -1;
         } else {
             if ( cnt > 0 ) {
                 // newline signals end of line;skip trailing newline
	         if ( buf[0] == '\n' ){
                     if (  !cr_found ) {
                        printf("carriege return not found:\n");
	                ReadLine.line[ReadLine.len]='\0';
                     }
	             return ReadLine.len;
                 }
                 // Carriage return signals end of data
	         if ( buf[0] == '\r' ) { 
	             ReadLine.line[ReadLine.len]='\0';
                     cr_found=1;
                     continue;
	         }
	         ReadLine.line[ReadLine.len]=buf[0];
	         ReadLine.len++;
             } else {
                 if ( cnt == 0 ) {
                     perror("read_line end of file:connection closed");
                      //do dump to find out why file desc closed
                     //abort();
                     return 0; 
                 }
             }
         }
     }
     return -1;
}

void clear_request( void )
{
    free_string(&Request.uri);
    Request.uri=strdup("");
    //free_string(&Request.menu_level);
    //Request.menu_level=strdup(ROOT_URL);

    //free_memory((void**)&Request.stat_buf);

    free_string(&Request.uridata);
    Request.uridatalen=0;

    free_string(&Request.method);

    //Default to lowest ???
    Request.protocol_ver=(float)1.0;

    memset(Request.content_type,'\0',sizeof(Request.content_type));

    free_string(&Request.data);
    Request.datalen=0;

    free_string(&Request.action);
    free_string(&Request.target);

    clear_vars(&Request.header_variables);
    clear_vars(&Request.parameters);
    clear_vars(&Request.cookies);

    Request.curr_page=get_default_page();
    //Request.zero_read = 0;

}

void print_request_data(char **data, long datalen)
{
   printf("Request data len: %ld\n",datalen);
   printf("-----------------------------------\n");
   printf("Data: \"%*.*s\"",(int)datalen,(int)datalen,*data);
   printf("-----------------------------------\n");
}

void print_request( void )
{
    int i;
    //var_value_type *vvp;

    printf("\n\nREQUEST:\n");
    printf("----------------------------------------------------------\n");
    printf("URI: %s\n", Request.uri);
    //printf("Menu Level: %s\n", Request.menu_level);
    printf("METHOD CODE: %s\n",Request.method);
    printf("ACTION: %s\n",Request.action==NULL?"":Request.action);
    printf("TARGET: %s\n",Request.target==NULL?"":Request.target);
    //printf("CONNECTION CLOSE/KEEP-ALIVE: %s\n",
    //        (Connection.close==CLOSE?"close":(Connection.close==KEEP_ALIVE?"keep-alive":"")));

    printf("CONTENT TYPE: \"%s\"\n",Request.content_type);
    printf("PROTCOL VER: %f\n",Request.protocol_ver);
    printf("DATA LEN: %ld\n",Request.datalen);
    printf("DATA: <%*.*s>\n",Request.datalen,Request.datalen,Request.data);
    //printf("ZERO READ: %d\n",Request.zero_read); 

 printf("Num header variables: %d\n",Request.header_variables.len);
    for(i=0;i< Request.header_variables.len;i++) {
      if ( &Request.header_variables.vars[i] != NULL ) {
          printf("Header Variable(%d): %s = %*.*s len=%d\n",
                  i,Request.header_variables.vars[i].name,
                    Request.header_variables.vars[i].vallen,
                    Request.header_variables.vars[i].vallen,
                    Request.header_variables.vars[i].value,
                    Request.header_variables.vars[i].vallen);

      }
    }

    printf("Num parameters: %d\n",Request.parameters.len);
    for(i=0;i< Request.parameters.len;i++) {
      if ( &Request.parameters.vars[i] != NULL ) {
          printf("Parameter(%d): %s = %*.*s len=%d\n",
                  i,Request.parameters.vars[i].name,
                    Request.parameters.vars[i].vallen,
                    Request.parameters.vars[i].vallen,
                    Request.parameters.vars[i].value,
                    Request.parameters.vars[i].vallen);

      }
    }

    for(i=0;i< Request.cookies.len;i++) {
      if ( &Request.cookies.vars[i] != NULL ) {
          printf("Cookie(%d): %s = %*.*s len=%d\n",
                  i,Request.cookies.vars[i].name,
                    Request.cookies.vars[i].vallen,
                    Request.cookies.vars[i].vallen,
                    Request.cookies.vars[i].value,
                    Request.cookies.vars[i].vallen);

      }
    }
    printf("----------------------------------------------------------\n");
}

char *escape( char **pstr )
{
    char *str = *pstr;
    char *ptr=NULL;
    char *newstr=NULL;
    int len=0;
    if ( str ) {
        for(ptr=str; *ptr != '\0'; ptr++) {
           switch(*ptr) {
               case ' ': //*ptr='+';
                   newstr=realloc(newstr,len+1);
                   newstr[len]='+';
                   len++;
               break;
               default:
                 if ( !isalpha(*ptr) ) {
                     newstr=realloc(newstr,len+3);
                     sprintf(&newstr[len],"%%%x",*ptr);
                     len += 3;
                 } else {
                    newstr=realloc(newstr,len+1);
                    newstr[len]=*ptr;
                    len++;
                 }
           }
        }
        newstr=realloc(newstr,len+1);
        newstr[len]='\0';
        len++;
    } 
    //return str;
    return newstr;
}

//FIXME: problem with return on null string
long unescape( char **pstr, long *len )
{
    char *str = *pstr;
    char *ptr1=NULL,*ptr2=NULL;
    int val=0;
    long newlen=0;
    if ( str != NULL ) {
        ptr2=str;
        for(ptr1=str;*ptr1!='\0'; ptr1++) {
            switch(*ptr1) {
               default:
                  *ptr2 = *ptr1;
                   ptr2++;
                   newlen++;
               break;
               case '+': *ptr2=' ';
                   ptr2++;
                   newlen++;
               break;
               case '%':
                  sscanf(ptr1+1,"%2X",&val);
                  *ptr2=val;
                  ptr1+=2;
                  ptr2++;
                  newlen++;
               break;
               //Convert to UNIX format
               case '
':
                   ptr2++;
               break;
            }
        }
    }
    *ptr2='\0';
    *len = newlen;
    return newlen; 
}

int compare_string(const void *s1, const void *s2)
{
    return strcasecmp((char*)s1,(char*)s2);
}

char *find_header_value( char *var )
{
    var_value_type *cptr=NULL;
    cptr=(var_value_type*)bsearch(var,Request.header_variables.vars,Request.header_variables.len,
                                  sizeof(Request.header_variables.vars[0]),compare_string);
    if ( cptr  != NULL )
        return strdup(cptr->value);
    return NULL;
}

char *find_params_value(char *var )
{
    var_value_type *cptr=NULL;
    cptr=(var_value_type*)bsearch(var,Request.parameters.vars,Request.parameters.len,
                                  sizeof(Request.parameters.vars[0]),compare_string);
    if ( cptr  != NULL )
        return strdup(cptr->value);
    return NULL;
}

char *find_cookie_value(char *var )
{
    var_value_type *cptr=NULL;
    cptr=(var_value_type*)bsearch(var,Request.cookies.vars,Request.cookies.len,
                                  sizeof(Request.cookies.vars[0]),compare_string);
    if ( cptr  != NULL )
        return strdup(cptr->value);
    return NULL;
}

/*
int set_request_stat(char *pathname)
{
    int fd,ret,rret;
    char buf[1];

    Request.zero_read = 0;

    free_memory((void**)&Request.stat_buf);

    Request.stat_buf=malloc(sizeof(struct stat));
    memset(Request.stat_buf,0x0,sizeof(struct stat));
    ret=stat(pathname,Request.stat_buf);
    if ( ret == 0 ) {
        if ( S_ISREG(Request.stat_buf->st_mode) && Request.stat_buf->st_size==0){
            // Check to see if stat is lying to us like in /proc zero byte file
            memset(buf,0x0,sizeof(buf));
            fd=open(pathname,O_RDWR);
            if ( fd > 0 ) {
                rret=read(fd,buf,sizeof(buf));
                close(fd);
            }
            if ( rret >  0 ) {
               //stat lied; its size is not zero; it has readable content
               Request.zero_read=1;
            }
        }
    }
    return ret;
}

struct stat *get_request_stat( void )
{
   return  Request.stat_buf;
}
*/

int process_request( void )
{
    int tlen=0;
    int dlen=0;
    int blen=0;
    int ulen=0;
    int ret=0,pid=-1;
    char *ptr=NULL;
    char cwdpath[PATH_MAX],tmppath[PATH_MAX];

    syslog(LOG_ERR|LOG_USER,"process_request: starting");

    set_statement_default();
    set_default_curr_page();
    clear_response();

    //FIXME: need macros for this .....
    if ( Request.protocol_ver < 1.0 && Request.protocol_ver > 1.1 ) {
        setup_error(RC_HTTP_VERSION_NOT_SUPPORTED,
            "The request uses a version %f of HTTP that is not supported: %s",
                 Request.protocol_ver);
        goto send_page;
    }

    if ( session_authenticated() ) {
        if ( get_session_s_addr()!= connection_get_connection_s_addr() )
        {
            syslog(LOG_ERR|LOG_USER,"do_mode_menu: Out of session connection from: %s",
                   inet_ntoa(connection_get_connection_sin_addr()));
            setup_error(RC_INTERNAL_SERVER_ERROR,"There is a problem with the page you are trying to reach and it cannot be displayed.");
            goto send_page;
        }
    }

    getcwd(cwdpath,sizeof(cwdpath));
    memset(tmppath,0x0,sizeof(tmppath));
    sprintf(tmppath,"%s%s",cwdpath,Request.uri);
    syslog(LOG_ERR|LOG_USER,"process_request: tmppath: %s",tmppath);
    if ( !url_in_page_table(Request.uri) ) {
         //set_request_stat(tmppath);
         pid=send_file(tmppath);
         if ( pid < 0 ) {
             goto send_page;
         } else {
             goto dont_send;
         }
    } else {

    Request.curr_page=get_page_by_url(Request.uri);

    if ( Request.curr_page == NULL ) {
        setup_error(RC_NOT_FOUND,
                    "The server has not found anything matching the Request-URI: %s",Request.uri);
        goto send_page;
    }

//split_request:

        tlen=strlen(Request.uri);
        ulen = strlen(Request.curr_page->url);
        ptr = &Request.uri[ulen];
        if ( *ptr == path_sep ) {
           ulen++;
           ptr++;
        }

        dlen = ptr-&Request.uri[0];
        //free_string(&Request.menu_level);
        //Request.menu_level=strdup(Request.curr_page->url);

        blen = strlen(ptr)+1;
        memcpy(Request.uri,ptr,blen);
        memset(&Request.uri[blen],0x0,tlen-blen);

        syslog(LOG_ERR|LOG_USER,"process_request: Uri:%s",Request.uri);

        //syslog(LOG_ERR|LOG_USER,"process_request: Uri:%s MenuLevel: %s",
        //       Request.uri,Request.menu_level);

        ret=process_authenticate();

        switch( ret ) {
           case CHALLENGE_SENT:
                goto dont_send;
           break;
           case AUTH:
               if (  Request.curr_page->page->handler != NULL ) {
                   ret =   Request.curr_page->page->handler();
                   if ( ret == SEND_PAGE ) {
                       goto send_page;
                    } else {
                       goto dont_send;
                    }
                } else {
                    setup_error(RC_NOT_FOUND,
                       "The server has not found anything matching the Request-URI: %s",Request.uri);
                    goto send_page;
                 }
           break;
           case NOTAUTH:
               goto send_page;
           break;
        }
    }

dont_send:

   syslog(LOG_ERR|LOG_USER,"process_request: end page not sent");
   return 0;

send_page:

    send_response();
    //print_response();
    clear_response();
    syslog(LOG_ERR|LOG_USER,"process_request: end page sent");
    return 0;

}


void process_files( void )
{
    register int i,j;
    FILE *fp;
    struct stat buf;
    int ret;
    char filename[PATH_MAX];

    memset(filename,0x0,sizeof(filename));
    for(i=0;i< Request.parameters.len;i++) {
        if ( &Request.parameters.vars[i] != NULL ) {
            if ( strlen(Request.parameters.vars[i].name) > 0 ){
                memset(&buf,0x0,sizeof(buf));
                ret=stat(Request.parameters.vars[i].name,&buf);
                if ( ret == 0 ) {
                    if ( S_ISREG(buf.st_mode) ){
                        // Catonate multiple file areas together; if same filename
                        if ( strcasecmp(filename,Request.parameters.vars[i].name) != 0 ) {
                            memset(filename,0x0,sizeof(filename));
                            memcpy(filename,Request.parameters.vars[i].name,
                                   strlen(Request.parameters.vars[i].name));
                            truncate(Request.parameters.vars[i].name,0L);
                        }
                        // cheap dude's dos2unix
                        //fp=fopen(Request.parameters.vars[i].name,"w+");
                        fp=fopen(Request.parameters.vars[i].name,"a+");
                        j=0;
                        while( j < Request.parameters.vars[i].vallen) {
                           if ( 
                               Request.parameters.vars[i].value[j] != '\r' &&
                               Request.parameters.vars[i].value[j] != '\0'
                              ) 
                              {
                                  fputc(Request.parameters.vars[i].value[j],fp);
                              }
                           j++;
                        }
                        // for text file last char must be a newline????
                        if ( Request.parameters.vars[i].value[j] != '\n' ) {
                            fputc('\n',fp);
                        }
                        fclose(fp);
                    }
                }
            }
        }
    }
}

void process_params( void )
{
    register int i, len;
    //const statement_type *statement;
    statement_type *statement;
    piece_type  value;
    char *ptr_new;
    char buf[256],buf2[256];

    for(i=0;i< Request.parameters.len;i++) {
        if ( &Request.parameters.vars[i] != NULL ) {
            if ( strlen(Request.parameters.vars[i].name) > 0 && 
                memcmp(Request.parameters.vars[i].name,"0x",2) == 0 ) {
                statement=NULL;
                if ( sscanf(Request.parameters.vars[i].name,"%p",&statement) == 1) {
	            value = statement->sb_symbol->value;
                    if ( statement->verb == verb_ask_hex ||
                       statement->verb == verb_dep_hex || 
                       statement->verb == verb_ask_int || 
                       statement->verb == verb_dep_int ||
                       statement->verb == verb_ask_string ||
                       statement->verb == verb_dep_string ) {
                            char *c;
                            free_string(&statement->err_mess);
                            /*if (  statement -> err_mess != NULL) {
                                  free(statement->err_mess);
                                  statement->err_mess=NULL;
                            }*/
                            // test for emtpty value?
                            len = 0;
                            memset(buf,0x0,sizeof(buf));
                            for( c=Request.parameters.vars[i].value; *c != '\0'; c++ ) {
                                if (!statement_allow_char(statement, *c)) {
                                   len=sprintf(&buf[len], "%c ",*c);
                                }
                            }
                            len = strlen(Request.parameters.vars[i].value);
			    ptr_new = grab_memory(len);
                            memcpy(ptr_new,Request.parameters.vars[i].value,len);
			    value.ptr = ptr_new;
                            value.len = len;
			    statement->sb_symbol->value = value;
			    statement->sb_symbol->origin = origin_statement;
                            // If error found; display mess but don't save
                            if ( buf[0] == '\0' ) {
                                set_response_error_found(0);
                            } else {
                                sprintf(buf2,"Illegal char: %s", buf);
                                statement -> err_mess=strdup(buf2);
                                set_response_error_found(1);
                            }
                    }
                }
            }
        }
    }
}

void set_request_curr_page_by_uri( char *uri )
{
    set_curr_page(get_page_by_url(uri));
}

page_table_type *get_request_curr_page(void)
{
	return Request.curr_page;
}

void set_curr_page( page_table_type *curr_page )
{
    if ( curr_page != NULL ) {
        Request.curr_page = curr_page;
    }
}

void set_curr_page_default( void )
{
    set_curr_page(get_default_page());
}

request_type *get_request( void ) 
{
    return &Request;
}

char *get_request_uri(void)
{
    return Request.uri;
}
char *get_uridata(void)
{
    return Request.uridata;
}

/*
char *get_request_menu_level(void)
{
    return Request.menu_level;
}

void set_request_menu_level(char *menu_level)
{
    reset_string_value(&Request.menu_level,&menu_level);
}
*/

long get_uridatalen(void)
{
    return Request.uridatalen;
}

/*
struct stat *get_stat_buf(void)
{
    return Request.stat_buf;
}
*/

char  *get_request_method(void)
{
     return Request.method;
}
/*
char  *get_menu_level(void)
{
    return Request.menu_level;
}
*/

char *get_content_type(void)
{
     return Request.content_type;
}

float get_protocol_ver(void)
{
    return Request.protocol_ver;
}

vv_array_type get_header_variables(void)
{
    return Request.header_variables;
}
vv_array_type get_parameters(void)
{
    return Request.parameters;
}
vv_array_type get_cookies(void)
{
    return Request.cookies;
}
char *get_request_action(void)
{
    return Request.action;
}

void set_request_action(char *action)
{
    reset_string_value(&Request.action,&action);
}

char *get_request_target(void)
{
    return Request.target;
}

void set_request_target(char *target)
{
    reset_string_value(&Request.target,&target);
}


long  get_datalen(void)
{
    return Request.datalen;
}

char *get_data(void)
{
    return Request.data;
}

/*
int get_zero_read(void)
{
    return Request.zero_read;
}
int is_zero_read( void )
{
    return (Request.zero_read == 1);
}
*/

int Params_index;

void init_params( void )
{
   Params_index = 0;
}

int more_params( void )
{
    return (Params_index <  Request.parameters.len);
}

void next_param( void )
{
  Params_index++;
}

var_value_type *get_curr_param( void )
{
    return &Request.parameters.vars[Params_index];
}

void set_default_curr_page( void )
{
    Request.curr_page=get_default_page();
}


