/*
 * Copyright (c) 2005 Kirk Murrin, <mailto:linuxguru1968@yahoo.com>
 * Licensed under the Gnu Public License, version 2.
 * All rights resered.
 * 
 */


//#define _GNU_SOURCE
#include <string.h>

#include "mconfig.h"
#include "pages.h"
#include "vv_array.h"

#ifndef _REQUEST_H
#define _REQUEST_H

#define MAX_LINE    512  // Max size of input/output line
typedef  struct struct_line {
     char line[MAX_LINE];
     int len;
} line_type;

#define MAX_READ_LINE    512

typedef enum struct_uri_type {
    ILLEGAL_URI=0,
    ROOT_URI,
    DISK_FILE,
    MENU_LINK 
} request_uri_type;

typedef struct struct_request {
    char *uri;
    char *uridata;
    long uridatalen;
    //struct stat *stat_buf;
    char  *method;
    //char  *menu_level;
    char  content_type[75];
    float protocol_ver;
    page_table_type *curr_page;
    vv_array_type header_variables;
    vv_array_type parameters;
    vv_array_type cookies;
    char *action;
    char *target;
    long  datalen;
    char *data;
    //int zero_read; 
} request_type;

int read_line(int sd);
int read_request( void );
int parse_request_line( void );
int parse_parameters(char **str, long len );
void print_request( void );
void print_request_data(char **data, long datalen);
void clear_request(void);
int set_request_stat(char *pathname);
char *find_header_value( char *var );
char *find_params_value( char *var );
char *find_cookie_value( char *var );
int set_request_stat(char *pathname);
int process_request( void );
void set_curr_page( page_table_type *curr_page );
void set_curr_page_default( void );
request_type *get_request( void ); 

void process_params( void );
void process_files( void );
long unescape( char **pstr, long *len );
char *escape( char **pstr );

char *get_request_uri(void);
char *get_uridata(void);
long get_uridatalen(void);
int split_uri( char **str, long strlen );
//struct stat *get_stat_buf(void);
char *get_request_method(void);
char *get_menu_level(void);
char *get_content_type(void);
float get_protocol_ver(void);
page_table_type *get_request_curr_page(void);
vv_array_type get_header_variables(void);
vv_array_type get_parameters(void);
vv_array_type get_cookies(void);
char *get_request_action(void);
char *get_request_target(void);
void set_request_action(char *action);
void set_request_target( char *target );
long  get_datalen(void);
char *get_data(void);
int get_zero_read(void); 
//int is_zero_read( void );
//struct stat *get_request_stat( void );
char *get_request_menu_level(void);
void set_request_menu_level(char *menu_level);
void init_params( void );
int more_params( void );
void next_param( void );
var_value_type *get_curr_param( void );
int compare_string(const void *s1, const void *s2);
void set_default_curr_page( void );
void set_request_curr_page_by_uri( char *uri );

#endif
